%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Learning program: learn_test_relations_SemEval.m
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% input: Word2Vec inputs for SemEval dataset (79 relations)
%% output: relational weight distributions *mu.mat, *sigma.mat, and result summary *rsttemp.mat
%% Psuedo-code
% for each relation i 
% 	construct positive examples and negative examples
% 	do feature augmentation
% 		for each word pair j
% 			compute difference vector f1- f2
% 			rank order difference features rank(f1- f2)
% concatenate difference vectors 
% concatenate raw vectors and ranked vectors 
% 		end for
% 		
% 	do feature selection
% 		input concatenated difference vectors from the training data
% 		run lassoglm with Elastic-Net regularization
% 		output selected feature dimensions as s(.) and associated coefficients ?
% 		construct selected feature vectors 
% 
% 	do variational Bayesian learning
% 		input selected feature vectors from the training data, regression coefficients
% 		compute empirical prior [?, - ?]
% 		run variational Bayesian learning
% 		output posterior distribution of weights
% 
% end for

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Test program: TestVebAnalogyfunc().m
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function input parameters: (learnrstpath,outputrstpath), the pathway for learned relational representation and output rst path
% model input: BART learned relational representation (*mu.mat, *sigma.mat), and Word2Vec inputs for UCLA Vebal Analogy dataset
% output: Analogy decision,saved in 'rst.UCLAAnalogy.mat'
% note this function will take a few hours on a PC computer with CPU


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Test program: TestConverseRel.m
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This program aims to test converse relations identification using
% transformation of converse_func. For example, the BART learned weapon:spear, tree: oak. test: red: color, robin:bird
% input: BART learned relational representation (*mu.mat, *sigma.mat), and
% Word2Vec inputs for SemEval
% output: test accuracy for wordpairs with converse relation

